package dao;

import static org.junit.Assert.assertTrue;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class HsqldbTest {

	public PostDAO postDAO = null;

	public PostDTO postDTO = null;

	@Before
	public void createTable() {		
		postDAO = DAOFactory.getDAOFactory(DAOFactory.HSQLDB).getPostDAO();
		try { postDAO.dropTable(); } catch (Exception e) { System.out.println("ho provato a dropparla, ma magari non esisteva gia' di suo..");		}
		postDAO.createTable();
		//
		postDTO = new PostDTO();
		postDTO.setId(0);
		// SimpleDateFormat from the J2EE Javadoc API on the course web site
		postDTO.setGiorno( new SimpleDateFormat("EEE, MMM d, ''yy").format(new Date()));
		postDTO.setOra( new SimpleDateFormat("h:mm a").format(new Date()));
		postDTO.setTesto("testiamo il testo");
	}

	@After
	public void dropTable() {
		postDAO.dropTable();
		postDAO = null;
		postDTO = null;
	}

	// ------------------------------------------------

	@Test
	public void testCreateAndReadUser1() {
		int postDTO_id = postDAO.createPost(postDTO);
		assertTrue("Created post gets non negative id",postDTO_id >= 0);
		assertTrue("Created users are read correctly",postDTO.getTesto().equals(postDAO.readPost(postDTO_id).getTesto()));
		assertTrue("Created users are read correctly",postDTO.getGiorno().equals(postDAO.readPost(postDTO_id).getGiorno()));
		assertTrue("Created users are read correctly",postDTO.getOra().equals(postDAO.readPost(postDTO_id).getOra()));
	}
}
